#!/bin/sh
set -u
set -e

# EVIL shell script to setup local homes for Mill machines

evil() {
	line="$@"
	OLDIFS="$IFS"
	IFS=:
	set -- $line
	home=$6
	user=$1
	uid=$3
	gid=$4
	IFS="$OLDIFS"

	# re-create their home drive
	if echo "$home" | grep ^/home >/dev/null; then
		if [ ! -d "$home" ]; then
			mkdir -p "$home"
			( cd /etc/skel && tar cf - . ) | ( cd "$home" && tar xf - )
			chown -R "$uid" "$home"
			chgrp -R "$gid" "$home"
			chmod 750 "$home"
		fi

		echo "smb://CAMPUS;$user@homes.cs/$user/ Your Linux Home Folder" >\
			"$home/.gtk-bookmarks"
		[ -h "$home/linux_shared_folder" ] || {
			ln -s "$home/.gvfs/$user on homes.cs" "$home/linux_shared_folder"
		}
	fi
}

if [ $# = 1 ]; then
	evil "$(getent passwd "$1")"
else
	while read line; do evil "$line"; done < /etc/passwd
fi
